/***********************************    EditFenster   ***************************
* Java-Addressmanager - Frontend for managing personal contacts
* Copyright (c) 2002  - Thomas Ruschival t.ruschival@vivid-md.de
*   For  license details read LICENSE
* CVS:
* $Author: ruschi $
* $Date: 2004/09/14 15:33:04 $
* $Revision: 1.2 $ 
*     
*******************************************************************************/

import java.util.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;


/*
|| Editfenster ist ein Singeton, es kann immer nur ein Editierfenster offen sein.
|| Der Inhalt kann aber durch aendern des Kontakts in AddMan aktualisiert werden. 
*/

public class EditFenster extends JFrame{
 // Instanz von sich selbst
 private static EditFenster instance = null;


/*
|| ActionListener, die registrieren ob sich eingaben veraendert haben
*/
 KeyListener ModAnschriftListener = new KeyAdapter(){
  public void keyTyped(KeyEvent evt){
   Control.AnschriftModified = true;
  }
 };
 
 KeyListener ModPersonListener = new KeyAdapter(){
  public void keyTyped(KeyEvent evt){
   Control.PersonModified = true;
  }
 };
 
 KeyListener ModEmailListener = new KeyAdapter(){
  public void keyTyped(KeyEvent evt){
   Control.EmailModified = true;
  }
 };

 KeyListener ModPhoneListener = new KeyAdapter(){
  public void keyTyped(KeyEvent evt){
   Control.PhoneModified = true;
  }
 };
   
/*
|| Komponeneten
*/
 private Container rahmen;
 // einzelne Karteikarten
 private static JPanel General_tab = new JPanel();
 public static JPanel Mail_tab    = new JPanel();
 private static JPanel Email_tab   = new JPanel();
 private static JPanel Phone_tab   = new JPanel();
 private static JPanel Group_tab  = new JPanel();
 private static JPanel Other_tab   = new JPanel();

 //Layoutmanager fuer  Tabs
 private static GridBagLayout Email_tablayout  = new GridBagLayout();
 private static GridBagLayout Mail_tablayout  = new GridBagLayout();
 private static GridBagLayout General_tablayout  = new GridBagLayout();
 private static GridBagLayout Phone_tablayout  = new GridBagLayout();
 private static GridBagLayout Group_tablayout  = new GridBagLayout();
 private static GridBagConstraints gbc;
 
 /*
 || Label fuer Feldnamen, die nicht weiter bearbeitet werden
 */
 public static JTabbedPane Reiter = new JTabbedPane();
 private static int oldSelectedPanel = 0;
   // General_tab
 private FeldLabel lab_name   = new FeldLabel("Surame: ");
 private FeldLabel lab_vorname   = new FeldLabel("Name: ");
 private FeldLabel lab_nickname   = new FeldLabel("Nickname: ");
 private FeldLabel lab_bday    = new FeldLabel("Date of birth: ");
 private JPanel    Bday_Panel  = new JPanel();
  // Email_tab
 private FeldLabel lab_mailto   = new FeldLabel("mailto: "); 
 private FeldLabel lab_email_komm  = new FeldLabel("Comment: ");
  // Mail_tab
 private FeldLabel lab_anschrift  = new FeldLabel("Address: ");
 private FeldLabel lab_plz    = new FeldLabel("ZIP-Code: ");
 private FeldLabel lab_stadt   = new FeldLabel("City: ");
 private FeldLabel lab_land   = new FeldLabel("Country: ");
 private FeldLabel lab_adress_komm  = new FeldLabel("Comment: ");
  // Phone_tab
 private FeldLabel lab_telefonnr  = new FeldLabel("Number: "); 
 private FeldLabel lab_telefon_komm  = new FeldLabel("Comment: ");
 private FeldLabel lab_telefontyp  = new FeldLabel("Type: "); 
  
 /*
 || Label die Personenbezogen ihren Text aendern
 */
  // Eigenschaften in General_tab 
 public JTextField Vname          = new JTextField(new String(),20);
 public JTextField Nname          = new JTextField(new String(),20);
 public JTextField Nickname       = new JTextField(new String(),20);
 public JTextField Bday_day       = new JTextField(new String(),2);
 public JTextField Bday_month     = new JTextField(new String(),2);
 public JTextField Bday_year     = new JTextField(new String(),4);  
  //  Eigenschaften in Email_tab            
 public JTextField Email          = new JTextField(new String(),30);
 public JTextArea Email_komm     = new JTextArea(new String(),2,30);
 public JScrollPane Email_komm_scroll  = new JScrollPane(Email_komm);
 public JList  Email_list       = new JList();
 public JScrollPane Email_scroll    = new JScrollPane(Email_list); 
 public JList  Group_list      = new JList(AddMan.getGroups().toArray());
 public JScrollPane Group_scroll    = new JScrollPane(Group_list); 
  //  Eigenschaften in Mail_tab     
 public JTextArea Anschrift      = new JTextArea(new String(),2,30);
 public JScrollPane Anschrift_scroll   = new JScrollPane(Anschrift);
 public JTextField Plz       = new JTextField(new String(),15);
 public JTextField Stadt       = new JTextField(new String(),15);
 public JTextField Land       = new JTextField(new String(),15);
 public JTextArea Anschrift_komm    = new JTextArea(new String(),2,30);
 public JScrollPane Anschrift_komm_scroll = new JScrollPane(Anschrift_komm);
 public JList  Anschrift_list      = new JList();
 public JScrollPane Anschrift_list_scroll = new JScrollPane(Anschrift_list);  
  //  Eigenschaften in Phone_tab       
 public JTextField Telefonnr      = new JTextField(new String(),20);
 public JTextArea  Telefon_komm     = new JTextArea(new String(),2,20);
 public JScrollPane Telefon_komm_scroll   = new JScrollPane(Telefon_komm);
 public JComboBox Telefontyp     = new JComboBox(AddMan.TelefonTypListe);
 public JList  Telefon_list      = new JList();
 public JScrollPane Telefon_scroll    = new JScrollPane(Telefon_list); 

 /*
 ||Buttons
 */ 
  // Buttons um Veraenderungen speichern
 JButton ModEmailButton    	= new JButton("modify",new ImageIcon(this.getClass().getResource("modify.png")));
 JButton ModAnschriftButton = new JButton("modify",new ImageIcon(this.getClass().getResource("modify.png")));
 JButton ModTelefonButton   = new JButton("modify",new ImageIcon(this.getClass().getResource("modify.png")));
 JButton ModPersonButton    = new JButton("modify",new ImageIcon(this.getClass().getResource("modify.png")));
  // Button fuer weitere Attribute  
 JButton AddEmailButton    	= new JButton("add",new ImageIcon(this.getClass().getResource("add.png")));
 JButton AddAnschriftButton = new JButton("add",new ImageIcon(this.getClass().getResource("add.png")));
 JButton AddTelefonButton   = new JButton("add",new ImageIcon(this.getClass().getResource("add.png")));
  // Button um Attribute zu loeschen 
 JButton RemEmailButton    	= new JButton("remove",new ImageIcon(this.getClass().getResource("delete.png")));
 JButton RemAnschriftButton = new JButton("remove",new ImageIcon(this.getClass().getResource("delete.png")));
 JButton RemTelefonButton   = new JButton("remove",new ImageIcon(this.getClass().getResource("delete.png")));
  
 /* Class  to Control DataChanges */
 private static EditFensterControl Control;

/*
|| Quasi konstruktoren
*/ 
 // Methode um Objekt zu bekommen.
  public static EditFenster getInstance(){
    if(instance == null){
      instance = new EditFenster();
      Control = new EditFensterControl(instance);
      instance.setIconImage(instance.getToolkit().getImage(getInstance().getClass().getResource("icon.png")));
      instance.setLocation(50,50);
      instance.layoutInstance();  
  
      /*******************
       * Action Listener
       ******************/
    
      // Keyevents auf Textfelder  
      instance.Plz.addKeyListener(instance.ModAnschriftListener);
      instance.Stadt.addKeyListener(instance.ModAnschriftListener);
      instance.Land.addKeyListener(instance.ModAnschriftListener);
      instance.Anschrift.addKeyListener(instance.ModAnschriftListener);
      instance.Anschrift_komm.addKeyListener(instance.ModAnschriftListener);
     
      instance.Email.addKeyListener(instance.ModEmailListener);       
      instance.Email_komm.addKeyListener(instance.ModEmailListener);     
   
      instance.Telefonnr.addKeyListener(instance.ModPhoneListener);        
      instance.Telefon_komm.addKeyListener(instance.ModPhoneListener);  
    
      instance.Vname.addKeyListener(instance.ModPersonListener);     
      instance.Nname.addKeyListener(instance.ModPersonListener);     
      instance.Nickname.addKeyListener(instance.ModPersonListener);  
      instance.Bday_day.addKeyListener(instance.ModPersonListener);  
      instance.Bday_month.addKeyListener(instance.ModPersonListener);
      instance.Bday_year.addKeyListener(instance.ModPersonListener); 

      // ActionListener Der registriert, wenn sich der Focus auf den TabbedPanes aendert
      instance.Reiter.addChangeListener(new ChangeListener(){
          public void stateChanged(ChangeEvent e){
            if(Control.PersonModified == true){
              showChangedDialog("General");
            }
            if(Control.AnschriftModified == true){
              showChangedDialog("Mail");
            }
            if(Control.EmailModified == true){
              showChangedDialog("Email");
            }
            if(Control.PhoneModified == true){
              showChangedDialog("Phone");
            }
            oldSelectedPanel = ((JTabbedPane)e.getSource()).getSelectedIndex();
          } 
        });
 
      // Event fuer fenster
      instance.setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
      instance.addWindowListener(new WindowAdapter(){
          public void windowClosing(WindowEvent evt){
            if(Control.PersonModified || Control.AnschriftModified || Control.EmailModified  || Control.PhoneModified){
              showExitDialog();
            }
            else{
              instance.setVisible(false);
            } 
          }
        });    
    
      // Auswahl in Emailliste
      instance.Email_list.addListSelectionListener(new ListSelectionListener(){
          public void valueChanged(ListSelectionEvent e){
            instance.selectMail();
          }
        });
      // Auswahl in Addressliste
      instance.Anschrift_list.addListSelectionListener(new ListSelectionListener(){
          public void valueChanged(ListSelectionEvent e){
            instance.selectAnschrift();
          }
        });
      // Auswahl inTelefonliste
      instance.Telefon_list.addListSelectionListener(new ListSelectionListener(){
          public void valueChanged(ListSelectionEvent e){
            instance.selectTelefon();
          }
        });
  
      // ActionListener auf die Buttons legen
   
      //Stammdaten in General_tab veraendern
      instance.ModPersonButton.addActionListener(new ActionListener(){
          public void actionPerformed(ActionEvent e){
            Control.ModPerson();
          }
        });
      /*
        || Anschrift Daten 
      */ 
      //Daten der Anschrift veraendern
      instance.ModAnschriftButton.addActionListener(new ActionListener(){
          public void actionPerformed(ActionEvent e){
            Control.ModAnschrift();
          }
        });
      //Daten der Anschrift hinzufuegen
      instance.AddAnschriftButton.addActionListener(new ActionListener(){
          public void actionPerformed(ActionEvent e){
            Control.AddAnschrift();
          }
        });	
      //Daten der Anschrift Loeschen
      instance.RemAnschriftButton.addActionListener(new ActionListener(){
          public void actionPerformed(ActionEvent e){
            Control.RemAnschrift();
          }
        });
		
		
      /*
		|| Email Daten 
      */
      //Daten der Email veraendern
      instance.ModEmailButton.addActionListener(new ActionListener(){
          public void actionPerformed(ActionEvent e){
            Control.ModEmail();	
          }
        });
      //Daten der Email hinzufuegen
      instance.AddEmailButton.addActionListener(new ActionListener(){
          public void actionPerformed(ActionEvent e){
            Control.AddEmail();
          }
        });
      //Daten der Email loeschen
      instance.RemEmailButton.addActionListener(new ActionListener(){
          public void actionPerformed(ActionEvent e){
            Control.RemEmail();
          }
        });
		
		
      /*
		|| Telefon
      */
      //Daten Telefon veraendern
      instance.ModTelefonButton.addActionListener(new ActionListener(){
          public void actionPerformed(ActionEvent e){
            Control.ModPhone();
          }
        });
      //Daten Telefon hinzufuegen
      instance.AddTelefonButton.addActionListener(new ActionListener(){
          public void actionPerformed(ActionEvent e){
            Control.AddPhone();
          }
        });
      //Daten Telefon loeschen-
      instance.RemTelefonButton.addActionListener(new ActionListener(){
          public void actionPerformed(ActionEvent e){
            Control.RemPhone();
          }
        });
    }
    instance.updateData();
    instance.setVisible(true);		
    return instance;
  }

  // Konstruktor 
  private EditFenster(){
    super("Edit Contact");
  }

  //Pruefen ob es ein EditFenster gibt, da AddMan es ggf updaten muss
  public static EditFenster exists(){
    return instance;
  }

  /*
    || Methoden
  */	
  // angezeigte Daten aktualisieren 
  public void updateData(){
    if(AddMan.Kontakt != null){
      updateGeneral_tab(AddMan.Kontakt);
      updateMail_tab(AddMan.Kontakt);
      updateEmail_tab(AddMan.Kontakt);
      updatePhone_tab(AddMan.Kontakt); 
    }
  }
	
  /*
    || Tabfelder mit Daten Fuellen, Wenn eine Person ausgewaehlt wird
  */ 
  // General_tab
  public void updateGeneral_tab(Person myperson) {
    Vname.setText(myperson.getVname());
    Nname.setText(myperson.getNname());
    Nickname.setText(myperson.getNickname());
    Bday_day.setText(myperson.getBday_day());
    Bday_month.setText(myperson.getBday_month());
    Bday_year.setText(myperson.getBday_year());
  }
  // Email_tab
  public void updateEmail_tab(Person myperson){		
     Email.setText(null);
     Email_komm.setText(null);
 
	// Gruppenliste fuellen
    Group_list.setListData(AddMan.getGroups().toArray());
    // Emailliste fuellen
    Email_list.setListData(myperson.getEmail().toArray());
    // Wenn es Keine Email  gibt kann auch kein Label gesetzt werden
    try{Email_list.setSelectedIndex(0);}
    catch(java.lang.ArrayIndexOutOfBoundsException exc){
	   }
  }
  // Mail_tab
  public void updateMail_tab(Person myperson){
      Anschrift.setText(null);
      Plz.setText(null);
      Stadt.setText(null);
      Land.setText(null);
      Anschrift_komm.setText(null);
    Anschrift_list.setListData(myperson.getPostAddress().toArray());
    // Wenn es Keine Adresse  gibt kann auch kein Label gesetzt werden
    try{Anschrift_list.setSelectedIndex(0);}
    catch(java.lang.ArrayIndexOutOfBoundsException exc){  }
  }
  // Phone_tab
  public void updatePhone_tab(Person myperson){
    Telefonnr.setText(null);
    Telefon_komm.setText(null);
	Telefon_list.setListData(myperson.getTelefon().toArray());
    // Wenn es Keine Adresse  gibt kann auch kein Label gesetzt werden
    try{Telefon_list.setSelectedIndex(0);}
    catch(java.lang.ArrayIndexOutOfBoundsException exc){ }
  }
	
	
  /*
    || Methoden fuer ActionListener
  */
  //  Kommentar und angezeigte mailadresse aendern
  public void selectMail(){
    if(Email_list.getSelectedIndex() != -1){
      Email list_item = (Email)Email_list.getSelectedValue();
      // Label setzen
      Email_komm.setText(list_item.getKomment());
      Email.setText(list_item.getAddress());
      // Gruppenliste selektieren
      Group_list.setSelectedIndices(list_item.getGroupIndices());
    }
  }
  // Anschrift Lables fuellen
  public void selectAnschrift(){
    if(Anschrift_list.getSelectedIndex() != -1){
      Postadresse list_item = (Postadresse)Anschrift_list.getSelectedValue();
      Anschrift_komm.setText(list_item.getKomment());
      Anschrift.setText(list_item.getAnschrift());
      Land.setText(list_item.getLand());
      Stadt.setText(list_item.getStadt());
      Plz.setText(list_item.getPLZ());
    }
  }
  // TelefonLabels fuellen
  public void selectTelefon(){ 
    if(Telefon_list.getSelectedIndex() != -1){
      Telefon list_item = (Telefon) Telefon_list.getSelectedValue();
      Telefonnr.setText(list_item.getNummer());
      Telefontyp.setSelectedIndex(list_item.getTyp());
      Telefon_komm.setText(list_item.getKomment());
    }
  }
		

  //Instance Layouten, alle Items reinlegen etc.
  public void layoutInstance(){
    rahmen = instance.getContentPane();
    Reiter.setPreferredSize(new Dimension(400,350));
    Reiter.addTab("General",new ImageIcon(this.getClass().getResource("general.png")), General_tab,"gereral information");
    Reiter.addTab("Mail"   ,new ImageIcon(this.getClass().getResource("anschrift.png")), Mail_tab,  "snailmail");
    Reiter.addTab("Email"  ,new ImageIcon(this.getClass().getResource("email.png")), Email_tab, "email list");
    Reiter.addTab("Phone"  ,new ImageIcon(this.getClass().getResource("phone.png")), Phone_tab, "telephone");
    // Alle TabbedPanes "layouten"
    tabLayout();	
    //Layout fertigstellen
    rahmen.add(Reiter);
    instance.pack();
  }
	

  /*
	|| Methode Layouted alle TabbedPanes im mittleren Rahmen
  */
  public void tabLayout(){
    /*
      ||  Layout fuer Generaltab:
    */
    General_tab.setLayout(General_tablayout);
    //Nachname Feld 
    gbc = Fenster.makegrid(0,0,1,1,100,0);
    gbc.anchor= GridBagConstraints.WEST;
    General_tablayout.setConstraints(lab_name,gbc);
    General_tab.add(lab_name);
    //Nachname Daten
    gbc = Fenster.makegrid(1,0,2,1,100,0);
    gbc.anchor= GridBagConstraints.WEST;
    General_tablayout.setConstraints(Nname,gbc);
    General_tab.add(Nname);
    //Vorname Feld
    gbc = Fenster.makegrid(0,1,1,1,100,0);
    gbc.anchor= GridBagConstraints.WEST;
    General_tablayout.setConstraints(lab_vorname,gbc);
    General_tab.add(lab_vorname);
    // Vorname Daten
    gbc = Fenster.makegrid(1,1,2,1,100,0);
    gbc.anchor= GridBagConstraints.WEST;
    General_tablayout.setConstraints(Vname,gbc);
    General_tab.add(Vname);
    // Nichname Feld
    gbc = Fenster.makegrid(0,2,1,1,100,0);
    gbc.anchor= GridBagConstraints.WEST;
    General_tablayout.setConstraints(lab_nickname,gbc);
    General_tab.add(lab_nickname);
    // Nickname Daten
    gbc = Fenster.makegrid(1,2,2,1,100,0);
    gbc.anchor = GridBagConstraints.WEST;
    General_tablayout.setConstraints(Nickname,gbc);
    General_tab.add(Nickname);
    //Geburtstag - Feld
    gbc = Fenster.makegrid(0,3,1,1,100,0);
    gbc.anchor= GridBagConstraints.WEST;
    General_tablayout.setConstraints(lab_bday,gbc);
    General_tab.add(lab_bday);
    //Geburtstag - Daten
    gbc = Fenster.makegrid(1,3,2,1,0,0);
    gbc.anchor= GridBagConstraints.WEST;
    General_tablayout.setConstraints(Bday_Panel,gbc);
    General_tab.add(Bday_Panel);
    Bday_Panel.setLayout( new FlowLayout(FlowLayout.LEFT,5,0));
    Bday_Panel.add(Bday_day);
    Bday_Panel.add(Bday_month);
    Bday_Panel.add(Bday_year);
    // Leeres Feld fuer einheitliches Design
    gbc = Fenster.makegrid(0,4,2,2,100,100);
    JLabel empty_lab = new JLabel();
    General_tablayout.setConstraints(empty_lab,gbc);
    General_tab.add(empty_lab);
    //Modify-knopf
    gbc = Fenster.makegrid(0,6,1,1,0,0);
    General_tablayout.setConstraints(ModPersonButton,gbc);
    General_tab.add(ModPersonButton);
			
    /*		
        ||Layout fuer Emailtab:
    */
    Email_tab.setLayout(Email_tablayout);
    //Email Feld
    gbc = Fenster.makegrid(0,0,3,1,100,0);
    gbc.anchor= GridBagConstraints.WEST;
    Email_tablayout.setConstraints(lab_mailto,gbc);
    Email_tab.add(lab_mailto);
    // Email Daten
    gbc = Fenster.makegrid(0,1,3,1,100,0);
    gbc.anchor= GridBagConstraints.WEST;
    Email_tablayout.setConstraints(Email,gbc);
    Email_tab.add(Email);
    //Kommentar  Feld
    gbc = Fenster.makegrid(0,2,3,1,100,0);
    gbc.anchor= GridBagConstraints.WEST;
    Email_tablayout.setConstraints(lab_email_komm,gbc);
    Email_tab.add(lab_email_komm);
    //Kommentar Daten
    gbc = Fenster.makegrid(0,3,3,1,100,0);
    gbc.anchor= GridBagConstraints.WEST;
    Email_tablayout.setConstraints(Email_komm_scroll,gbc);
    Email_tab.add(Email_komm_scroll);
    // Liste der Emailaddressen
    gbc = Fenster.makegrid(0,5,2,1);
    gbc.fill = GridBagConstraints.BOTH;
    Email_tablayout.setConstraints(Email_scroll,gbc);
    Email_tab.add(Email_scroll);
    // Gruppenliste
    gbc = Fenster.makegrid(2,5,1,1);
    gbc.fill = GridBagConstraints.BOTH;
    Email_tablayout.setConstraints(Group_scroll,gbc);
    Email_tab.add(Group_scroll);		
    //Modify Knopf
    gbc = Fenster.makegrid(0,6,1,1,100,0);
    Email_tablayout.setConstraints(ModEmailButton,gbc);
    Email_tab.add(ModEmailButton);
    //Add Knopf
    gbc = Fenster.makegrid(1,6,1,1,100,0);
    Email_tablayout.setConstraints(AddEmailButton,gbc);
    Email_tab.add(AddEmailButton);
    //Remove Knopf
    gbc = Fenster.makegrid(2,6,1,1,100,0);
    Email_tablayout.setConstraints(RemEmailButton,gbc);
    Email_tab.add(RemEmailButton);
			
    /*
      || Layout fuer Addresstab
    */
    Mail_tab.setLayout(Mail_tablayout);
    //Anschrift Feld 
    gbc = Fenster.makegrid(0,0,3,1,100,0);
    gbc.anchor= GridBagConstraints.WEST;
    Mail_tablayout.setConstraints(lab_anschrift,gbc);
    Mail_tab.add(lab_anschrift);
    //Anschrift  Daten
    gbc = Fenster.makegrid(0,1,3,1);
    gbc.anchor= GridBagConstraints.WEST;
    Mail_tablayout.setConstraints(Anschrift_scroll,gbc);
    Mail_tab.add(Anschrift_scroll);
    //PLZ Feld
    gbc = Fenster.makegrid(0,2,1,1,100,0);
    gbc.anchor= GridBagConstraints.WEST;
    Mail_tablayout.setConstraints(lab_plz,gbc);
    Mail_tab.add(lab_plz);
    // PLZ Daten
    gbc = Fenster.makegrid(1,2,2,1,100,0);
    gbc.anchor= GridBagConstraints.WEST;
    Mail_tablayout.setConstraints(Plz,gbc);
    Mail_tab.add(Plz);
    // Stadt Feld
    gbc = Fenster.makegrid(0,3,1,1,100,0);
    gbc.anchor= GridBagConstraints.WEST;
    Mail_tablayout.setConstraints(lab_stadt,gbc);
    Mail_tab.add(lab_stadt);
    // Stadt Daten
    gbc = Fenster.makegrid(1,3,2,1,100,0);
    gbc.anchor = GridBagConstraints.WEST;
    Mail_tablayout.setConstraints(Stadt,gbc);
    Mail_tab.add(Stadt);
    //Land - Feld
    gbc = Fenster.makegrid(0,4,1,1,100,0);
    gbc.anchor= GridBagConstraints.WEST;
    Mail_tablayout.setConstraints(lab_land,gbc);
    Mail_tab.add(lab_land);
    //Land - Daten
    gbc = Fenster.makegrid(1,4,2,1,100,0);
    gbc.anchor= GridBagConstraints.WEST;
    Mail_tablayout.setConstraints(Land,gbc);
    Mail_tab.add(Land);
    //Anschrift - Kommentar feld
    gbc = Fenster.makegrid(0,5,3,1,100,0);
    gbc.anchor= GridBagConstraints.WEST;
    Mail_tablayout.setConstraints(lab_adress_komm,gbc);
    Mail_tab.add(lab_adress_komm);
    //Anschrift - KommentarDaten
    gbc = Fenster.makegrid(0,6,3,2);
    gbc.anchor= GridBagConstraints.WEST;
    Mail_tablayout.setConstraints(Anschrift_komm_scroll,gbc);
    Mail_tab.add(Anschrift_komm_scroll);
    // Liste der Postaddressen
    gbc = Fenster.makegrid(0,8,3,2);
    gbc.fill = GridBagConstraints.BOTH;
    Mail_tablayout.setConstraints(Anschrift_list_scroll,gbc);
    Mail_tab.add(Anschrift_list_scroll);
    //Modify Knopf
    gbc = Fenster.makegrid(0,10,1,1,100,0);
    Mail_tablayout.setConstraints(ModAnschriftButton,gbc);
    Mail_tab.add(ModAnschriftButton);
    //Add Knopf
    gbc = Fenster.makegrid(1,10,1,1,100,0);
    Mail_tablayout.setConstraints(AddAnschriftButton,gbc);
    Mail_tab.add(AddAnschriftButton);
    //RemoveKnopf
    gbc = Fenster.makegrid(2,10,1,1,100,0);
    Mail_tablayout.setConstraints(RemAnschriftButton,gbc);
    Mail_tab.add(RemAnschriftButton);
		
    /*
      || Layout fuer Phone_tab
    */
    Phone_tab.setLayout(Phone_tablayout);
    //TelefonnrFeld 
    gbc = Fenster.makegrid(0,0,1,1,100,0);
    gbc.anchor= GridBagConstraints.WEST;
    Phone_tablayout.setConstraints(lab_telefonnr,gbc);
    Phone_tab.add(lab_telefonnr);
    //Telefonnr  Daten
    gbc = Fenster.makegrid(1,0,2,1,100,0);
    gbc.anchor= GridBagConstraints.WEST;
    Phone_tablayout.setConstraints(Telefonnr,gbc);
    Phone_tab.add(Telefonnr);
    //TelefonTyp Feld
    gbc = Fenster.makegrid(0,1,1,1,100,0);
    gbc.anchor= GridBagConstraints.WEST;
    Phone_tablayout.setConstraints(lab_telefontyp,gbc);
    Phone_tab.add(lab_telefontyp);
    // Telefontyp Daten
    gbc = Fenster.makegrid(1,1,2,1,100,0);
    gbc.anchor= GridBagConstraints.WEST;
    Phone_tablayout.setConstraints(Telefontyp,gbc);
    Phone_tab.add(Telefontyp);
    // Kommentar
    gbc = Fenster.makegrid(0,2,1,1,100,0);
    gbc.anchor= GridBagConstraints.WEST;
    Phone_tablayout.setConstraints(lab_telefon_komm,gbc);
    Phone_tab.add(lab_telefon_komm);
    // Kommentar Daten
    gbc = Fenster.makegrid(1,2,2,2,100,0);
    gbc.anchor = GridBagConstraints.WEST;
    Phone_tablayout.setConstraints(Telefon_komm_scroll,gbc);
    Phone_tab.add(Telefon_komm_scroll);
    // Liste der Telefonnummern
    gbc = Fenster.makegrid(0,4,3,2);
    gbc.fill = GridBagConstraints.BOTH;
    Phone_tablayout.setConstraints(Telefon_scroll,gbc);
    Phone_tab.add(Telefon_scroll);
    //Modify Knopf
    gbc = Fenster.makegrid(0,6,1,1,0,0);
    Phone_tablayout.setConstraints(ModTelefonButton,gbc);
    Phone_tab.add(ModTelefonButton);
    //Modify Knopf
    gbc = Fenster.makegrid(1,6,1,1,0,0);
    Phone_tablayout.setConstraints(AddTelefonButton,gbc);
    Phone_tab.add(AddTelefonButton);
    //Modify Knopf
    gbc = Fenster.makegrid(2,6,1,1,0,0);
    Phone_tablayout.setConstraints(RemTelefonButton,gbc);
    Phone_tab.add(RemTelefonButton);             
  } 
	
	
  /*
	|| Methode generiert ExitDialog
  */
  private static int showExitDialog(){
    Object[] options = {"Ok", "Cancel"};
    int n = JOptionPane.showOptionDialog(instance,
                                         "Do you want to save changes",
                                         "Save Your work?",
                                         JOptionPane.YES_NO_OPTION,
                                         JOptionPane.QUESTION_MESSAGE,
                                         null,
                                         options,
                                         options[0]);
    if (n == JOptionPane.YES_OPTION) {
      instance.setVisible(false);
      Control.ModPerson();
      Control.ModAnschrift();
      Control.ModEmail();
      Control.ModPhone();
      return JOptionPane.YES_OPTION;
    } else if (n == JOptionPane.NO_OPTION){
      instance.setVisible(false);
      return JOptionPane.NO_OPTION;
    } else {
      instance.setVisible(true);
      return JOptionPane.CLOSED_OPTION;
    }	
  }
 
  private static int showChangedDialog(String item){
    Object[] options = {"Ok", "Cancel"};
    int n = JOptionPane.showOptionDialog(instance,
                                         "Do you want to save changes in " + item,
                                         "Save Your work?",
                                         JOptionPane.YES_NO_OPTION,
                                         JOptionPane.QUESTION_MESSAGE,
                                         null,
                                         options,
                                         options[0]);
    if (n == JOptionPane.YES_OPTION) {
      if (oldSelectedPanel== 0) Control.ModPerson();
      if (oldSelectedPanel== 1) Control.ModAnschrift();
      if (oldSelectedPanel== 2) Control.ModEmail();
      if (oldSelectedPanel== 3) Control.ModPhone();
      return JOptionPane.YES_OPTION;
    } else if (n == JOptionPane.NO_OPTION){
      if (oldSelectedPanel== 0) instance.updateGeneral_tab(AddMan.Kontakt);    
      if (oldSelectedPanel== 1) instance.updateMail_tab(AddMan.Kontakt); 
      if (oldSelectedPanel== 2) instance.updateEmail_tab(AddMan.Kontakt);     
      if (oldSelectedPanel== 3) instance.updatePhone_tab(AddMan.Kontakt);   
      return JOptionPane.NO_OPTION;
    } else {
      return JOptionPane.CLOSED_OPTION;
    }	
  }	                    
}

