/********************************* EditFensterControl ***************************
* Java-Addressmanager - Frontend for managing personal contacts
* Copyright (c) 2002  - Thomas Ruschival t.ruschival@vivid-md.de
*		 For  license details read LICENSE
* CVS:
* $Author: ruschi $
* $Date: 2004/09/14 15:33:04 $
* $Revision: 1.2 $ 
*				 
*******************************************************************************/
import java.util.Collections;
class EditFensterControl{
	private static EditFenster Fenster;
	/*
	|| Flags for Changes
	*/ 	
	public static boolean PersonModified 		= false;
	public static boolean AnschriftModified 	= false;
	public static boolean EmailModified 		= false;
    public static boolean PhoneModified 		= false;

	/** Constructor expects a window to control */
	public EditFensterControl(EditFenster myWindow){
		this.Fenster = myWindow;
	}
	
	/** Method changes general properties of contact */
	public void ModPerson(){
		if(AddMan.Kontakt != null){
			java.util.Date Bday = new java.util.Date();
			try{
				Bday= AddMan.DFMT.parse(Fenster.Bday_day.getText() + "."
									   +Fenster.Bday_month.getText()  + "."
									   +Fenster.Bday_year.getText());
			}
			catch(java.text.ParseException exc){
					AddMan.win.showErrorMessage("Error parsing Birthday [EditFensterControl.ModPerson()] :"+ exc.getMessage());
			}
			AddMan.Kontakt.setVname(Fenster.Vname.getText());
			AddMan.Kontakt.setNname(Fenster.Nname.getText());
			AddMan.Kontakt.setNickname(Fenster.Nickname.getText());		
			AddMan.Kontakt.setBday(Bday);
			Collections.sort(AddMan.myUsers);
   		}
		Fenster.updateGeneral_tab(AddMan.Kontakt);
		PersonModified = false;
		AddMan.datachanged=true;
	}
	
	/** Method changes Mailaddress properties */ 
	public void ModAnschrift(){
		try{
			Postadresse list_item = (Postadresse) Fenster.Anschrift_list.getSelectedValue();
			list_item.setStadt(Fenster.Stadt.getText());
			list_item.setPLZ(Fenster.Plz.getText());
			list_item.setLand(Fenster.Land.getText());
			list_item.setAnschrift(Fenster.Anschrift.getText());	
			list_item.setKomment(Fenster.Anschrift_komm.getText());
		}
		catch(Exception exc){
			AddAnschrift();
		}
		AnschriftModified = false;
		AddMan.datachanged=true;
		Fenster.updateMail_tab(AddMan.Kontakt);
	} 
	  
	/** Method adds Mailaddress */ 
	public void AddAnschrift(){
		// new Snailmail
		Postadresse mypost;
		if(Fenster.Anschrift.getText().length() != 0 
			&& Fenster.Stadt.getText().length() != 0){
			mypost = new Postadresse(
				Fenster.Anschrift.getText(),
				Fenster.Stadt.getText(),
				0,
				Fenster.Land.getText(),
				Fenster.Anschrift_komm.getText(),
				Fenster.Plz.getText());
			//add Snailmail 
			mypost.Modified = true;
			AddMan.Kontakt.addAnschrift(mypost);
			Fenster.updateMail_tab(AddMan.Kontakt);
		}
		AddMan.datachanged=true;
		AnschriftModified = false;
	}
	 
	/** Method removes Mailaddress */  
	public void RemAnschrift(){
		try{
			int index =  Fenster.Anschrift_list.getSelectedIndex();
			if(index != -1){
				Postadresse mypost = (Postadresse) Fenster.Anschrift_list.getSelectedValue();
				AddMan.Kontakt.removeAnschrift(index);
			}
			Fenster.updateMail_tab(AddMan.Kontakt);
		}
		catch(ArrayIndexOutOfBoundsException exc){}	
		AddMan.datachanged=true;
	}
	
	/** Method modifies Email entity  */
	public void ModEmail(){
		try{
			Email list_item = (Email) Fenster.Email_list.getSelectedValue();
			if(Fenster.Email.getText().length() != 0 ){
				list_item.setAddress(Fenster.Email.getText());
				list_item.setKomment(Fenster.Email_komm.getText());
				list_item.setGroups(Fenster.Group_list.getSelectedValues());
			}
		}
		catch(Exception exc){
			AddEmail();
		}
		AddMan.datachanged=true;
		Fenster.updateEmail_tab(AddMan.Kontakt);
		EmailModified = false;			
	}
	
	/** Method adds Email entity */
	public void AddEmail(){
		//Neue Email
		Email mymail; 
		if(Fenster.Email.getText().length() != 0){
			mymail = new Email(
				Fenster.Email.getText(),
				Fenster.Email_komm.getText(),
				0			
			);
			// add email, write to Database if Handle exists
			mymail.Modified = true;
			mymail.setGroups(Fenster.Group_list.getSelectedValues());
			AddMan.Kontakt.addEmail(mymail);
			Fenster.updateEmail_tab(AddMan.Kontakt);
		}
	   AddMan.datachanged=true;
	   EmailModified = false;	
	}
	
	/** Method removes Email entity */ 
	public void RemEmail(){
		try{
			Email mymail = (Email) Fenster.Email_list.getSelectedValue();
			int index =  Fenster.Email_list.getSelectedIndex();
			if(index != -1){
				AddMan.Kontakt.removeEmail(index);
   			}
		}
		catch(ArrayIndexOutOfBoundsException exc){}
		AddMan.datachanged=true;
		Fenster.updateEmail_tab(AddMan.Kontakt);	
	} 
	
	/** Method modifies Phone entities */
	public void ModPhone(){
		try{
			Telefon list_item = (Telefon) Fenster.Telefon_list.getSelectedValue();
			if(Fenster.Telefonnr.getText().length() != 0){
				list_item.setNummer(Fenster.Telefonnr.getText());
				list_item.setKomment(Fenster.Telefon_komm.getText());
				list_item.setTyp(Fenster.Telefontyp.getSelectedIndex());
			}
		}
		catch(Exception exc){
			AddPhone();
		}
		Fenster.updatePhone_tab(AddMan.Kontakt);	
		AddMan.datachanged=true;
		PhoneModified = false;			
	}
	
	/** Method adds Phone entity*/
	public void AddPhone(){ 
		//Neues Telefon
		Telefon myphone;
		if(Fenster.Telefonnr.getText().length() != 0 ){
			myphone = new Telefon(
				Fenster.Telefonnr.getText(),
				Fenster.Telefon_komm.getText(),
				0,
				Fenster.Telefontyp.getSelectedIndex()
			);
			//add Phone 
			myphone.Modified = true;
			AddMan.Kontakt.addPhone(myphone);
			Fenster.updatePhone_tab(AddMan.Kontakt);
		}
		AddMan.datachanged=true;
		PhoneModified = false;
	}
	
	/** Method removes Phone entity */
	public void RemPhone(){ 
		try{
			Telefon myphone = (Telefon) Fenster.Telefon_list.getSelectedValue();
			int index =  Fenster.Telefon_list.getSelectedIndex();
			if(index != -1) AddMan.Kontakt.removePhone(index);
			PhoneModified = false;
		}
		catch(Exception exc){}
		AddMan.datachanged=true;
		Fenster.updatePhone_tab(AddMan.Kontakt);
	}
}
